#!/usr/bin/perl -w
use strict;
#ircGraph 0.6.7 - lusers to rrdtool 
#Copyright (C) 2001 Ricardo Sartori
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-
#
#Sugestoes e criticas (sem flames!!) mailto:sartori@lrv.ufsc.br
#Suggestions and critics (no flames!) mailto:sartori@lrv.ufsc.br
#
# Read config file to fetch the pidfile var

# Edit this variable to fit your needs. This command will be executed
# when this script finds out that ircgraph is not running anymore
my($command)="/some/path/to/ircgraph.pl -c /some/path/to/ircgraph.conf &";

# You probably dont need to edit anything more

if (!(defined($ARGV[0]))) {
  die("Error: You must specify a pidfile in the command line\nTry something like this: ./igchek.pl ircgraph.pid\n");
}

my($pidfile)=$ARGV[0];

if ((-e $pidfile) && (-r $pidfile)) { # if there is a pidfile
	open(PIDFILE, "<$pidfile"); # let's check if pid is running
	my($pid)=<PIDFILE>; close(PIDFILE);
	if (kill('CHLD', $pid) == 0) {
		print("Seems that the process is not running, firing the process\n");
		if (unlink($pidfile) != 1) { print("WARN: Could not erase pidfile $pidfile: ($!)\n"); };
		system("$command\n")==0 || die("Error on execution of $command ($!)\n");
	}
} else {
	print("No pidfile ($pidfile), firing the process\n");
	system("$command\n")==0 || die("Error on execution of $command ($!)\n");
}
exit(0);
